Loading...
Searching...
No Matches
ggrqf: generalized RQ factorization of an M-by-N matrix A and a P-by-N matrix B
Dense LA » Orthogonal/unitary factorizations » RQ factorization

## Functions

magma_int_t | magma_cggrqf (magma_int_t m, magma_int_t p, magma_int_t n, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *taua, magmaFloatComplex *B, magma_int_t ldb, magmaFloatComplex *taub, magmaFloatComplex *work, magma_int_t lwork, magma_int_t *info)
| CGGRQF computes a generalized RQ factorization of an M-by-N matrix A and a P-by-N matrix B:
magma_int_t | magma_dggrqf (magma_int_t m, magma_int_t p, magma_int_t n, double *A, magma_int_t lda, double *taua, double *B, magma_int_t ldb, double *taub, double *work, magma_int_t lwork, magma_int_t *info)
| DGGRQF computes a generalized RQ factorization of an M-by-N matrix A and a P-by-N matrix B:
magma_int_t | magma_sggrqf (magma_int_t m, magma_int_t p, magma_int_t n, float *A, magma_int_t lda, float *taua, float *B, magma_int_t ldb, float *taub, float *work, magma_int_t lwork, magma_int_t *info)
| SGGRQF computes a generalized RQ factorization of an M-by-N matrix A and a P-by-N matrix B:
magma_int_t | magma_zggrqf (magma_int_t m, magma_int_t p, magma_int_t n, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *taua, magmaDoubleComplex *B, magma_int_t ldb, magmaDoubleComplex *taub, magmaDoubleComplex *work, magma_int_t lwork, magma_int_t *info)
| ZGGRQF computes a generalized RQ factorization of an M-by-N matrix A and a P-by-N matrix B:

## Detailed Description

## Function Documentation

## magma_cggrqf()

magma_int_t magma_cggrqf | ( | magma_int_t | m,
|  | magma_int_t | p,
|  | magma_int_t | n,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | taua,
|  | magmaFloatComplex * | B,
|  | magma_int_t | ldb,
|  | magmaFloatComplex * | taub,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

CGGRQF computes a generalized RQ factorization of an M-by-N matrix A
and a P-by-N matrix B:

            A = R*Q,        B = Z*T*Q,

where Q is an N-by-N unitary matrix, Z is a P-by-P unitary
matrix, and R and T assume one of the forms:

if M <= N, R = ( 0 R12 ) M, or if M > N, R = ( R11 ) M-N,
N-M M ( R21 ) N
N

where R12 or R21 is upper triangular, and

if P >= N, T = ( T11 ) N , or if P < N, T = ( T11 T12 ) P,
( 0 ) P-N P N-P
N

where T11 is upper triangular.

In particular, if B is square and nonsingular, the GRQ factorization
of A and B implicitly gives the RQ factorization of A*inv(B):

             A*inv(B) = (R*inv(T))*Z'

where inv(B) denotes the inverse of the matrix B, and Z' denotes the
conjugate transpose of the matrix Z.

Parameters

  [in] | m | INTEGER The number of rows of the matrix A. M >= 0.
  [in] | p | INTEGER The number of rows of the matrix B. P >= 0.
  [in] | n | INTEGER The number of columns of the matrices A and B. N >= 0.

  [in,out]

  A

  COMPLEX array, dimension (LDA,N)
  On entry, the M-by-N matrix A.
  On exit, if M <= N, the upper triangle of the subarray
  A(1:M,N-M+1:N) contains the M-by-M upper triangular matrix R;
  if M > N, the elements on and above the (M-N)-th subdiagonal
  contain the M-by-N upper trapezoidal matrix R; the remaining
  elements, with the array TAUA, represent the unitary
  matrix Q as a product of elementary reflectors (see Further
  Details).

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M).
  [out] | taua | COMPLEX array, dimension (min(M,N)) The scalar factors of the elementary reflectors which represent the unitary matrix Q (see Further Details).
  [in,out] | B | COMPLEX array, dimension (LDB,N) On entry, the P-by-N matrix B. On exit, the elements on and above the diagonal of the array contain the min(P,N)-by-N upper trapezoidal matrix T (T is upper triangular if P >= N); the elements below the diagonal, with the array TAUB, represent the unitary matrix Z as a product of elementary reflectors (see Further Details).
  [in] | ldb | INTEGER The leading dimension of the array B. LDB >= max(1,P).
  [out] | taub | COMPLEX array, dimension (min(P,N)) The scalar factors of the elementary reflectors which represent the unitary matrix Z (see Further Details).
  [out] | work | (workspace) COMPLEX array, dimension (LWORK) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.

  [in]

  lwork

  INTEGER
  The dimension of the array WORK. LWORK >= max(1,N,M,P).
  For optimum performance LWORK >= max(N,M,P)*NB,
  where NB is the optimal blocksize for the QR factorization of a P-by-N matrix.
  If LWORK = -1, then a workspace query is assumed; the routine
  only calculates the optimal size of the WORK array, returns
  this value as the first entry of the WORK array, and no error
  message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO=-i, the i-th argument had an illegal value.

## Further Details

The matrix Q is represented as a product of elementary reflectors

Q = H(1) H(2) . . . H(k), where k = min(m,n).

Each H(i) has the form

H(i) = I - taua * v * v'

where taua is a complex scalar, and v is a complex vector with
v(n-k+i+1:n) = 0 and v(n-k+i) = 1; v(1:n-k+i-1) is stored on exit in
A(m-k+i,1:n-k+i-1), and taua in TAUA(i).
To form Q explicitly, use LAPACK subroutine ZUNGRQ.
To use Q to update another matrix, use LAPACK subroutine CUNMRQ.

The matrix Z is represented as a product of elementary reflectors

Z = H(1) H(2) . . . H(k), where k = min(p,n).

Each H(i) has the form

H(i) = I - taub * v * v'

where taub is a complex scalar, and v is a complex vector with
v(1:i-1) = 0 and v(i) = 1; v(i+1:p) is stored on exit in B(i+1:p,i),
and taub in TAUB(i).
To form Z explicitly, use LAPACK subroutine CUNGQR.
To use Z to update another matrix, use LAPACK subroutine CUNMQR.

## magma_dggrqf()

magma_int_t magma_dggrqf | ( | magma_int_t | m,
|  | magma_int_t | p,
|  | magma_int_t | n,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | taua,
|  | double * | B,
|  | magma_int_t | ldb,
|  | double * | taub,
|  | double * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

DGGRQF computes a generalized RQ factorization of an M-by-N matrix A
and a P-by-N matrix B:

            A = R*Q,        B = Z*T*Q,

where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
matrix, and R and T assume one of the forms:

if M <= N, R = ( 0 R12 ) M, or if M > N, R = ( R11 ) M-N,
N-M M ( R21 ) N
N

where R12 or R21 is upper triangular, and

if P >= N, T = ( T11 ) N , or if P < N, T = ( T11 T12 ) P,
( 0 ) P-N P N-P
N

where T11 is upper triangular.

In particular, if B is square and nonsingular, the GRQ factorization
of A and B implicitly gives the RQ factorization of A*inv(B):

             A*inv(B) = (R*inv(T))*Z'

where inv(B) denotes the inverse of the matrix B, and Z' denotes the
conjugate transpose of the matrix Z.

Parameters

  [in] | m | INTEGER The number of rows of the matrix A. M >= 0.
  [in] | p | INTEGER The number of rows of the matrix B. P >= 0.
  [in] | n | INTEGER The number of columns of the matrices A and B. N >= 0.

  [in,out]

  A

  DOUBLE PRECISION array, dimension (LDA,N)
  On entry, the M-by-N matrix A.
  On exit, if M <= N, the upper triangle of the subarray
  A(1:M,N-M+1:N) contains the M-by-M upper triangular matrix R;
  if M > N, the elements on and above the (M-N)-th subdiagonal
  contain the M-by-N upper trapezoidal matrix R; the remaining
  elements, with the array TAUA, represent the orthogonal
  matrix Q as a product of elementary reflectors (see Further
  Details).

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M).
  [out] | taua | DOUBLE PRECISION array, dimension (min(M,N)) The scalar factors of the elementary reflectors which represent the orthogonal matrix Q (see Further Details).
  [in,out] | B | DOUBLE PRECISION array, dimension (LDB,N) On entry, the P-by-N matrix B. On exit, the elements on and above the diagonal of the array contain the min(P,N)-by-N upper trapezoidal matrix T (T is upper triangular if P >= N); the elements below the diagonal, with the array TAUB, represent the orthogonal matrix Z as a product of elementary reflectors (see Further Details).
  [in] | ldb | INTEGER The leading dimension of the array B. LDB >= max(1,P).
  [out] | taub | DOUBLE PRECISION array, dimension (min(P,N)) The scalar factors of the elementary reflectors which represent the orthogonal matrix Z (see Further Details).
  [out] | work | (workspace) DOUBLE PRECISION array, dimension (LWORK) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.

  [in]

  lwork

  INTEGER
  The dimension of the array WORK. LWORK >= max(1,N,M,P).
  For optimum performance LWORK >= max(N,M,P)*NB,
  where NB is the optimal blocksize for the QR factorization of a P-by-N matrix.
  If LWORK = -1, then a workspace query is assumed; the routine
  only calculates the optimal size of the WORK array, returns
  this value as the first entry of the WORK array, and no error
  message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO=-i, the i-th argument had an illegal value.

## Further Details

The matrix Q is represented as a product of elementary reflectors

Q = H(1) H(2) . . . H(k), where k = min(m,n).

Each H(i) has the form

H(i) = I - taua * v * v'

where taua is a real scalar, and v is a real vector with
v(n-k+i+1:n) = 0 and v(n-k+i) = 1; v(1:n-k+i-1) is stored on exit in
A(m-k+i,1:n-k+i-1), and taua in TAUA(i).
To form Q explicitly, use LAPACK subroutine ZUNGRQ.
To use Q to update another matrix, use LAPACK subroutine DORMRQ.

The matrix Z is represented as a product of elementary reflectors

Z = H(1) H(2) . . . H(k), where k = min(p,n).

Each H(i) has the form

H(i) = I - taub * v * v'

where taub is a real scalar, and v is a real vector with
v(1:i-1) = 0 and v(i) = 1; v(i+1:p) is stored on exit in B(i+1:p,i),
and taub in TAUB(i).
To form Z explicitly, use LAPACK subroutine DORGQR.
To use Z to update another matrix, use LAPACK subroutine DORMQR.

## magma_sggrqf()

magma_int_t magma_sggrqf | ( | magma_int_t | m,
|  | magma_int_t | p,
|  | magma_int_t | n,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | taua,
|  | float * | B,
|  | magma_int_t | ldb,
|  | float * | taub,
|  | float * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

SGGRQF computes a generalized RQ factorization of an M-by-N matrix A
and a P-by-N matrix B:

            A = R*Q,        B = Z*T*Q,

where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
matrix, and R and T assume one of the forms:

if M <= N, R = ( 0 R12 ) M, or if M > N, R = ( R11 ) M-N,
N-M M ( R21 ) N
N

where R12 or R21 is upper triangular, and

if P >= N, T = ( T11 ) N , or if P < N, T = ( T11 T12 ) P,
( 0 ) P-N P N-P
N

where T11 is upper triangular.

In particular, if B is square and nonsingular, the GRQ factorization
of A and B implicitly gives the RQ factorization of A*inv(B):

             A*inv(B) = (R*inv(T))*Z'

where inv(B) denotes the inverse of the matrix B, and Z' denotes the
conjugate transpose of the matrix Z.

Parameters

  [in] | m | INTEGER The number of rows of the matrix A. M >= 0.
  [in] | p | INTEGER The number of rows of the matrix B. P >= 0.
  [in] | n | INTEGER The number of columns of the matrices A and B. N >= 0.

  [in,out]

  A

  REAL array, dimension (LDA,N)
  On entry, the M-by-N matrix A.
  On exit, if M <= N, the upper triangle of the subarray
  A(1:M,N-M+1:N) contains the M-by-M upper triangular matrix R;
  if M > N, the elements on and above the (M-N)-th subdiagonal
  contain the M-by-N upper trapezoidal matrix R; the remaining
  elements, with the array TAUA, represent the orthogonal
  matrix Q as a product of elementary reflectors (see Further
  Details).

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M).
  [out] | taua | REAL array, dimension (min(M,N)) The scalar factors of the elementary reflectors which represent the orthogonal matrix Q (see Further Details).
  [in,out] | B | REAL array, dimension (LDB,N) On entry, the P-by-N matrix B. On exit, the elements on and above the diagonal of the array contain the min(P,N)-by-N upper trapezoidal matrix T (T is upper triangular if P >= N); the elements below the diagonal, with the array TAUB, represent the orthogonal matrix Z as a product of elementary reflectors (see Further Details).
  [in] | ldb | INTEGER The leading dimension of the array B. LDB >= max(1,P).
  [out] | taub | REAL array, dimension (min(P,N)) The scalar factors of the elementary reflectors which represent the orthogonal matrix Z (see Further Details).
  [out] | work | (workspace) REAL array, dimension (LWORK) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.

  [in]

  lwork

  INTEGER
  The dimension of the array WORK. LWORK >= max(1,N,M,P).
  For optimum performance LWORK >= max(N,M,P)*NB,
  where NB is the optimal blocksize for the QR factorization of a P-by-N matrix.
  If LWORK = -1, then a workspace query is assumed; the routine
  only calculates the optimal size of the WORK array, returns
  this value as the first entry of the WORK array, and no error
  message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO=-i, the i-th argument had an illegal value.

## Further Details

The matrix Q is represented as a product of elementary reflectors

Q = H(1) H(2) . . . H(k), where k = min(m,n).

Each H(i) has the form

H(i) = I - taua * v * v'

where taua is a real scalar, and v is a real vector with
v(n-k+i+1:n) = 0 and v(n-k+i) = 1; v(1:n-k+i-1) is stored on exit in
A(m-k+i,1:n-k+i-1), and taua in TAUA(i).
To form Q explicitly, use LAPACK subroutine ZUNGRQ.
To use Q to update another matrix, use LAPACK subroutine SORMRQ.

The matrix Z is represented as a product of elementary reflectors

Z = H(1) H(2) . . . H(k), where k = min(p,n).

Each H(i) has the form

H(i) = I - taub * v * v'

where taub is a real scalar, and v is a real vector with
v(1:i-1) = 0 and v(i) = 1; v(i+1:p) is stored on exit in B(i+1:p,i),
and taub in TAUB(i).
To form Z explicitly, use LAPACK subroutine SORGQR.
To use Z to update another matrix, use LAPACK subroutine SORMQR.

## magma_zggrqf()

magma_int_t magma_zggrqf | ( | magma_int_t | m,
|  | magma_int_t | p,
|  | magma_int_t | n,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | taua,
|  | magmaDoubleComplex * | B,
|  | magma_int_t | ldb,
|  | magmaDoubleComplex * | taub,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

ZGGRQF computes a generalized RQ factorization of an M-by-N matrix A
and a P-by-N matrix B:

            A = R*Q,        B = Z*T*Q,

where Q is an N-by-N unitary matrix, Z is a P-by-P unitary
matrix, and R and T assume one of the forms:

if M <= N, R = ( 0 R12 ) M, or if M > N, R = ( R11 ) M-N,
N-M M ( R21 ) N
N

where R12 or R21 is upper triangular, and

if P >= N, T = ( T11 ) N , or if P < N, T = ( T11 T12 ) P,
( 0 ) P-N P N-P
N

where T11 is upper triangular.

In particular, if B is square and nonsingular, the GRQ factorization
of A and B implicitly gives the RQ factorization of A*inv(B):

             A*inv(B) = (R*inv(T))*Z'

where inv(B) denotes the inverse of the matrix B, and Z' denotes the
conjugate transpose of the matrix Z.

Parameters

  [in] | m | INTEGER The number of rows of the matrix A. M >= 0.
  [in] | p | INTEGER The number of rows of the matrix B. P >= 0.
  [in] | n | INTEGER The number of columns of the matrices A and B. N >= 0.

  [in,out]

  A

  COMPLEX_16 array, dimension (LDA,N)
  On entry, the M-by-N matrix A.
  On exit, if M <= N, the upper triangle of the subarray
  A(1:M,N-M+1:N) contains the M-by-M upper triangular matrix R;
  if M > N, the elements on and above the (M-N)-th subdiagonal
  contain the M-by-N upper trapezoidal matrix R; the remaining
  elements, with the array TAUA, represent the unitary
  matrix Q as a product of elementary reflectors (see Further
  Details).

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M).
  [out] | taua | COMPLEX_16 array, dimension (min(M,N)) The scalar factors of the elementary reflectors which represent the unitary matrix Q (see Further Details).
  [in,out] | B | COMPLEX_16 array, dimension (LDB,N) On entry, the P-by-N matrix B. On exit, the elements on and above the diagonal of the array contain the min(P,N)-by-N upper trapezoidal matrix T (T is upper triangular if P >= N); the elements below the diagonal, with the array TAUB, represent the unitary matrix Z as a product of elementary reflectors (see Further Details).
  [in] | ldb | INTEGER The leading dimension of the array B. LDB >= max(1,P).
  [out] | taub | COMPLEX_16 array, dimension (min(P,N)) The scalar factors of the elementary reflectors which represent the unitary matrix Z (see Further Details).
  [out] | work | (workspace) COMPLEX_16 array, dimension (LWORK) On exit, if INFO = 0, WORK(1) returns the optimal LWORK.

  [in]

  lwork

  INTEGER
  The dimension of the array WORK. LWORK >= max(1,N,M,P).
  For optimum performance LWORK >= max(N,M,P)*NB,
  where NB is the optimal blocksize for the QR factorization of a P-by-N matrix.
  If LWORK = -1, then a workspace query is assumed; the routine
  only calculates the optimal size of the WORK array, returns
  this value as the first entry of the WORK array, and no error
  message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO=-i, the i-th argument had an illegal value.

## Further Details

The matrix Q is represented as a product of elementary reflectors

Q = H(1) H(2) . . . H(k), where k = min(m,n).

Each H(i) has the form

H(i) = I - taua * v * v'

where taua is a complex scalar, and v is a complex vector with
v(n-k+i+1:n) = 0 and v(n-k+i) = 1; v(1:n-k+i-1) is stored on exit in
A(m-k+i,1:n-k+i-1), and taua in TAUA(i).
To form Q explicitly, use LAPACK subroutine ZUNGRQ.
To use Q to update another matrix, use LAPACK subroutine ZUNMRQ.

The matrix Z is represented as a product of elementary reflectors

Z = H(1) H(2) . . . H(k), where k = min(p,n).

Each H(i) has the form

H(i) = I - taub * v * v'

where taub is a complex scalar, and v is a complex vector with
v(1:i-1) = 0 and v(i) = 1; v(i+1:p) is stored on exit in B(i+1:p,i),
and taub in TAUB(i).
To form Z explicitly, use LAPACK subroutine ZUNGQR.
To use Z to update another matrix, use LAPACK subroutine ZUNMQR.